/* 
 * Leaflet Dynamic JSON Layer v0.1.8 - 2016-05-02 
 * 
 * Copyright 2016 Stefano Cudini 
 * stefano.cudini@gmail.com 
 * http://labs.easyblog.it/ 
 * 
 * Licensed under the MIT license. 
 * 
 * Demo: 
 * http://labs.easyblog.it/maps/leaflet-layerjson/ 
 * 
 * Source: 
 * git@github.com:stefanocudini/leaflet-layerjson.git 
 * 
 */
(function(){L.LayerJSON=L.FeatureGroup.extend({includes:L.Mixin.Events,options:{url:"",jsonpParam:null,callData:null,filterData:null,propertyItems:"",propertyTitle:"title",propertyLoc:"loc",locAsGeoJSON:!1,layerTarget:null,dataToMarker:null,onEachMarker:null,buildPopup:null,optsPopup:null,buildIcon:null,minZoom:10,caching:!0,minShift:1e3,updateOutBounds:!0,precision:6,attribution:""},initialize:function(a){L.FeatureGroup.prototype.initialize.call(this,[]),L.Util.setOptions(this,a),this._dataToMarker=this.options.dataToMarker||this._defaultDataToMarker,this._buildIcon=this.options.buildIcon||this._defaultBuildIcon,this._filterData=this.options.filterData||null,this._hashUrl=this.options.url,this._hashUrl?(this._callData=this.getAjax,this.options.jsonpParam&&(this._hashUrl+="&"+this.options.jsonpParam+"=",this._callData=this.getJsonp)):this._callData=this.options.callData,this._curReq=null,this._center=null,this._maxBounds=null,this._markersCache={}},onAdd:function(a){L.FeatureGroup.prototype.onAdd.call(this,a),this._center=a.getCenter(),this._maxBounds=a.getBounds(),a.on("moveend zoomend",this._onMove,this),this.update()},onRemove:function(a){a.off("moveend zoomend",this._onMove,this),L.FeatureGroup.prototype.onRemove.call(this,a);for(var b in this._layers)this._layers.hasOwnProperty(b)&&L.FeatureGroup.prototype.removeLayer.call(this,this._layers[b])},getAttribution:function(){return this.options.attribution},addLayer:function(a){return this.options.layerTarget?(this.options.layerTarget.addLayer.call(this.options.layerTarget,a),this.fire("layeradd",{layer:a})):(L.FeatureGroup.prototype.addLayer.call(this,a),this)},removeLayer:function(a){return this.options.layerTarget?(this.options.layerTarget.removeLayer.call(this.options.layerTarget,a),this.fire("layerremove",{layer:a})):(L.FeatureGroup.prototype.removeLayer.call(this,a),this)},clearLayers:function(){return this._markersCache={},this.options.layerTarget?this.options.layerTarget.clearLayers.call(this.options.layerTarget):L.FeatureGroup.prototype.clearLayers.call(this),this},_debouncer:function(a,b){var c;return b=b||300,function(){var d=this,e=arguments;clearTimeout(c),c=setTimeout(function(){a.apply(d,Array.prototype.slice.call(e))},b)}},_getPath:function(a,b){var c=b.split("."),d=c.pop(),e=c.length,f=c[0],g=1;if(e>0)for(;(a=a[f])&&e>g;)f=c[g++];return a?a[d]:void 0},_defaultBuildIcon:function(a,b){return new L.Icon.Default},_defaultDataToMarker:function(a,b){var c=this._getPath(a,this.options.propertyTitle),d=L.Util.extend({icon:this._buildIcon(a,c),title:c},a),e=new L.Marker(b,d),f=null;return this.options.buildPopup&&(f=this.options.buildPopup(a,e))&&e.bindPopup(f,this.options.optsPopup),e},addMarker:function(a){var b,c,d=this.options.propertyLoc;if(L.Util.isArray(d))b=L.latLng(parseFloat(this._getPath(a,d[0])),parseFloat(this._getPath(a,d[1])));else if(this.options.locAsGeoJSON){var e=this._getPath(a,d);b=L.latLng(e[1],e[0])}else b=L.latLng(this._getPath(a,d));c=[b.lat,b.lng].join()+this._getPath(a,this.options.propertyTitle),"undefined"==typeof this._markersCache[c]&&(this._markersCache[c]=this._dataToMarker(a,b)),this.options.onEachMarker&&this.options.onEachMarker(a,this._markersCache[c]),this._markersCache[c]&&this.addLayer(this._markersCache[c])},_markersCacheToLayer:function(a){for(var b in this._markersCache)this._markersCache[b]&&(a.contains(this._markersCache[b].getLatLng())?this.addLayer(this._markersCache[b]):this.removeLayer(this._markersCache[b]))},_onMove:function(a){var b=this._map.getZoom(),c=this._map.getCenter(),d=this._map.getBounds();if(b<this.options.minZoom)return!1;if(this.options.caching){if(this.options.minShift&&this._center.distanceTo(c)<this.options.minShift)return!1;if(this._center=c,this.options.updateOutBounds&&this._maxBounds.contains(d))return this._markersCacheToLayer(d),!1;this._maxBounds.extend(d)}else this.clearLayers();this.update()},update:function(){var a=this.options.precision,b=this._map.getBounds(),c=b.getSouthWest(),d=b.getNorthEast(),e=[[parseFloat(c.lat.toFixed(a)),parseFloat(c.lng.toFixed(a))],[parseFloat(d.lat.toFixed(a)),parseFloat(d.lng.toFixed(a))]];this._hashUrl&&(e=L.Util.template(this._hashUrl,{lat1:e[0][0],lon1:e[0][1],lat2:e[1][0],lon2:e[1][1]})),this._curReq&&this._curReq.abort&&this._curReq.abort();var f=this;f.fire("dataloading",{req:e}),this._curReq=this._callData(e,function(a){f._curReq=null,f._filterData&&(a=f._filterData(a)),f.options.propertyItems&&(a=f._getPath(a,f.options.propertyItems)),f.fire("dataloaded",{data:a});for(var b in a)f.addMarker.call(f,a[b])})},getAjax:function(url,cb){void 0===window.XMLHttpRequest&&(window.XMLHttpRequest=function(){try{return new ActiveXObject("Microsoft.XMLHTTP.6.0")}catch(a){try{return new ActiveXObject("Microsoft.XMLHTTP.3.0")}catch(b){throw new Error("XMLHttpRequest is not supported")}}});var request=new XMLHttpRequest;return request.open("GET",url),request.onreadystatechange=function(){var response={};if(4===request.readyState&&200===request.status){try{response=window.JSON?JSON.parse(request.responseText):eval("("+request.responseText+")")}catch(err){throw response={},new Error("Ajax response is not JSON")}cb(response)}},request.send(),request},getJsonp:function(a,b){var c=document.getElementsByTagName("body")[0],d=L.DomUtil.create("script","leaflet-layerjson-jsonp",c);return L.LayerJSON.callJsonp=function(a){b(a),c.removeChild(d)},d.type="text/javascript",d.src=a+"L.LayerJSON.callJsonp",{abort:function(){d.parentNode.removeChild(d)}}}}),L.layerJSON=function(a){return new L.LayerJSON(a)}}).call(this);